// -------------------------------------------------------------------------------------
// 
// RAMain.CS                                                      Ulrich Mller 17.12.05
//                                                                 PCS1700  C# Final SP2
// Steuerung einer Raupe (Typ Power Bulldozer) mit Greifer 
// durch Button oder Tasten : Fahren mit Pfeiltasten
//                            Vor, Rck, Drehen rechts / links, 
//                            LinksVor, RechtsVor, LinksRck, RechtsRck
//                            Greifer Hoch/Runter : Bild 
//                            Greifer Auf/Zu : Pos1 / Ende
// Erweiterung von RaupenGreif
//                          
// die Greifer-Befehle laufen durch Klick und sind fr erneute Bedienung solange gesperrt
//
// Interface-Belegung siehe Konstanten
//
// Einsatz FishFace40.DLL, Klasse FishFace40
//
// -------------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using FishFace40;

namespace RaupenAcht
{
	public class frmMain : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label lblStatus;
		private System.Windows.Forms.Label lblVersion;
		private System.Windows.Forms.Button cmdEnde;
		private System.Windows.Forms.Button cmdAction;
		private System.Windows.Forms.Panel pnlCommands;
		private System.Windows.Forms.Button cmdRight;
		private System.Windows.Forms.Button cmdLeft;
		private System.Windows.Forms.Button cmdForward;
		private System.Windows.Forms.Button cmdBack;
		private System.Windows.Forms.Button cmdGrAuf;
		private System.Windows.Forms.Button cmdGrZu;
		private System.Windows.Forms.Button cmdGrHoch;
		private System.Windows.Forms.Button cmdGrRunter;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.NumericUpDown nmGreifer;
		private System.Windows.Forms.Label lblReady;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Timer tmrSpannung;
		private System.Windows.Forms.Label lblSpannung;
		private System.ComponentModel.IContainer components;

		// --- Interface Konstanten ------------------------------
		private const int mLinks   = 1, mRechts   = 2;
		private const int cVor     = 2, cRuck     = 1, cAus = 0, cFull = 7;
		private const int mGreifer = 4, mHub      = 3;
		private const int eGrOffen = 7, eGrImpuls = 8;
		private const int cGrAuf   = 1, cGrZu     = 2;
		private const int eHubOben = 5, eHubUnten = 6;
		private const int cHubHoch = 1, cHubRunter= 2;
		private const int cBusy    = 0;

		private FishFace ft = new FishFace();
		private int GreiferStatus, HubStatus;
		private int GrCount, Speed;
		private System.Windows.Forms.Button cmdRightB;
		private System.Windows.Forms.Button cmdLeftB;
		private System.Windows.Forms.Button cmdRightF;
		private System.Windows.Forms.Button cmdLeftF;
		private System.Windows.Forms.Label label2;

		public frmMain()
		{
			InitializeComponent();

		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmMain));
			this.lblStatus = new System.Windows.Forms.Label();
			this.lblVersion = new System.Windows.Forms.Label();
			this.cmdEnde = new System.Windows.Forms.Button();
			this.cmdAction = new System.Windows.Forms.Button();
			this.pnlCommands = new System.Windows.Forms.Panel();
			this.cmdRightB = new System.Windows.Forms.Button();
			this.cmdLeftB = new System.Windows.Forms.Button();
			this.cmdRightF = new System.Windows.Forms.Button();
			this.cmdLeftF = new System.Windows.Forms.Button();
			this.cmdGrRunter = new System.Windows.Forms.Button();
			this.cmdGrHoch = new System.Windows.Forms.Button();
			this.cmdGrZu = new System.Windows.Forms.Button();
			this.cmdGrAuf = new System.Windows.Forms.Button();
			this.cmdBack = new System.Windows.Forms.Button();
			this.cmdForward = new System.Windows.Forms.Button();
			this.cmdRight = new System.Windows.Forms.Button();
			this.cmdLeft = new System.Windows.Forms.Button();
			this.nmGreifer = new System.Windows.Forms.NumericUpDown();
			this.label1 = new System.Windows.Forms.Label();
			this.lblReady = new System.Windows.Forms.Label();
			this.lblSpannung = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.tmrSpannung = new System.Windows.Forms.Timer(this.components);
			this.label2 = new System.Windows.Forms.Label();
			this.pnlCommands.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.nmGreifer)).BeginInit();
			this.SuspendLayout();
			// 
			// lblStatus
			// 
			this.lblStatus.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(224)), ((System.Byte)(224)), ((System.Byte)(224)));
			this.lblStatus.Location = new System.Drawing.Point(16, 232);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(272, 24);
			this.lblStatus.TabIndex = 5;
			this.lblStatus.Text = "ROBO RF Datalink : START";
			this.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblVersion
			// 
			this.lblVersion.Location = new System.Drawing.Point(16, 276);
			this.lblVersion.Name = "lblVersion";
			this.lblVersion.Size = new System.Drawing.Size(152, 16);
			this.lblVersion.TabIndex = 6;
			this.lblVersion.Text = "Version";
			// 
			// cmdEnde
			// 
			this.cmdEnde.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdEnde.Location = new System.Drawing.Point(176, 272);
			this.cmdEnde.Name = "cmdEnde";
			this.cmdEnde.Size = new System.Drawing.Size(112, 24);
			this.cmdEnde.TabIndex = 7;
			this.cmdEnde.Text = "Abbrechen";
			this.cmdEnde.Click += new System.EventHandler(this.cmdEnde_Click);
			// 
			// cmdAction
			// 
			this.cmdAction.Location = new System.Drawing.Point(176, 304);
			this.cmdAction.Name = "cmdAction";
			this.cmdAction.Size = new System.Drawing.Size(112, 24);
			this.cmdAction.TabIndex = 8;
			this.cmdAction.Text = "START";
			this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
			// 
			// pnlCommands
			// 
			this.pnlCommands.Controls.AddRange(new System.Windows.Forms.Control[] {
																					  this.cmdRightB,
																					  this.cmdLeftB,
																					  this.cmdRightF,
																					  this.cmdLeftF,
																					  this.cmdGrRunter,
																					  this.cmdGrHoch,
																					  this.cmdGrZu,
																					  this.cmdGrAuf,
																					  this.cmdBack,
																					  this.cmdForward,
																					  this.cmdRight,
																					  this.cmdLeft});
			this.pnlCommands.Enabled = false;
			this.pnlCommands.Location = new System.Drawing.Point(24, 16);
			this.pnlCommands.Name = "pnlCommands";
			this.pnlCommands.Size = new System.Drawing.Size(264, 152);
			this.pnlCommands.TabIndex = 9;
			// 
			// cmdRightB
			// 
			this.cmdRightB.Image = ((System.Drawing.Bitmap)(resources.GetObject("cmdRightB.Image")));
			this.cmdRightB.Location = new System.Drawing.Point(104, 104);
			this.cmdRightB.Name = "cmdRightB";
			this.cmdRightB.Size = new System.Drawing.Size(40, 40);
			this.cmdRightB.TabIndex = 20;
			this.cmdRightB.MouseUp += new System.Windows.Forms.MouseEventHandler(this.cmd_MouseUp);
			this.cmdRightB.MouseDown += new System.Windows.Forms.MouseEventHandler(this.cmdRightB_MouseDown);
			// 
			// cmdLeftB
			// 
			this.cmdLeftB.Image = ((System.Drawing.Bitmap)(resources.GetObject("cmdLeftB.Image")));
			this.cmdLeftB.Location = new System.Drawing.Point(8, 104);
			this.cmdLeftB.Name = "cmdLeftB";
			this.cmdLeftB.Size = new System.Drawing.Size(40, 40);
			this.cmdLeftB.TabIndex = 19;
			this.cmdLeftB.MouseUp += new System.Windows.Forms.MouseEventHandler(this.cmd_MouseUp);
			this.cmdLeftB.MouseDown += new System.Windows.Forms.MouseEventHandler(this.cmdLeftB_MouseDown);
			// 
			// cmdRightF
			// 
			this.cmdRightF.Image = ((System.Drawing.Bitmap)(resources.GetObject("cmdRightF.Image")));
			this.cmdRightF.Location = new System.Drawing.Point(104, 8);
			this.cmdRightF.Name = "cmdRightF";
			this.cmdRightF.Size = new System.Drawing.Size(40, 40);
			this.cmdRightF.TabIndex = 18;
			this.cmdRightF.MouseUp += new System.Windows.Forms.MouseEventHandler(this.cmd_MouseUp);
			this.cmdRightF.MouseDown += new System.Windows.Forms.MouseEventHandler(this.cmdRightF_MouseDown);
			// 
			// cmdLeftF
			// 
			this.cmdLeftF.Image = ((System.Drawing.Bitmap)(resources.GetObject("cmdLeftF.Image")));
			this.cmdLeftF.Location = new System.Drawing.Point(8, 8);
			this.cmdLeftF.Name = "cmdLeftF";
			this.cmdLeftF.Size = new System.Drawing.Size(40, 40);
			this.cmdLeftF.TabIndex = 17;
			this.cmdLeftF.MouseUp += new System.Windows.Forms.MouseEventHandler(this.cmd_MouseUp);
			this.cmdLeftF.MouseDown += new System.Windows.Forms.MouseEventHandler(this.cmdLeftF_MouseDown);
			// 
			// cmdGrRunter
			// 
			this.cmdGrRunter.Location = new System.Drawing.Point(168, 112);
			this.cmdGrRunter.Name = "cmdGrRunter";
			this.cmdGrRunter.Size = new System.Drawing.Size(88, 24);
			this.cmdGrRunter.TabIndex = 16;
			this.cmdGrRunter.Text = "Greifer Runter";
			this.cmdGrRunter.Click += new System.EventHandler(this.cmdGrRunter_Click);
			// 
			// cmdGrHoch
			// 
			this.cmdGrHoch.Location = new System.Drawing.Point(168, 80);
			this.cmdGrHoch.Name = "cmdGrHoch";
			this.cmdGrHoch.Size = new System.Drawing.Size(88, 24);
			this.cmdGrHoch.TabIndex = 15;
			this.cmdGrHoch.Text = "Greifer Hoch";
			this.cmdGrHoch.Click += new System.EventHandler(this.cmdGrHoch_Click);
			// 
			// cmdGrZu
			// 
			this.cmdGrZu.Location = new System.Drawing.Point(168, 48);
			this.cmdGrZu.Name = "cmdGrZu";
			this.cmdGrZu.Size = new System.Drawing.Size(88, 24);
			this.cmdGrZu.TabIndex = 14;
			this.cmdGrZu.Text = "Greifer Zu";
			this.cmdGrZu.Click += new System.EventHandler(this.cmdGrZu_Click);
			// 
			// cmdGrAuf
			// 
			this.cmdGrAuf.Location = new System.Drawing.Point(168, 16);
			this.cmdGrAuf.Name = "cmdGrAuf";
			this.cmdGrAuf.Size = new System.Drawing.Size(88, 24);
			this.cmdGrAuf.TabIndex = 13;
			this.cmdGrAuf.Text = "Greifer Auf";
			this.cmdGrAuf.Click += new System.EventHandler(this.cmdGrAuf_Click);
			// 
			// cmdBack
			// 
			this.cmdBack.Image = ((System.Drawing.Bitmap)(resources.GetObject("cmdBack.Image")));
			this.cmdBack.Location = new System.Drawing.Point(56, 104);
			this.cmdBack.Name = "cmdBack";
			this.cmdBack.Size = new System.Drawing.Size(40, 40);
			this.cmdBack.TabIndex = 12;
			this.cmdBack.MouseUp += new System.Windows.Forms.MouseEventHandler(this.cmd_MouseUp);
			this.cmdBack.MouseDown += new System.Windows.Forms.MouseEventHandler(this.cmdBack_MouseDown);
			// 
			// cmdForward
			// 
			this.cmdForward.Image = ((System.Drawing.Bitmap)(resources.GetObject("cmdForward.Image")));
			this.cmdForward.Location = new System.Drawing.Point(56, 8);
			this.cmdForward.Name = "cmdForward";
			this.cmdForward.Size = new System.Drawing.Size(40, 40);
			this.cmdForward.TabIndex = 11;
			this.cmdForward.MouseUp += new System.Windows.Forms.MouseEventHandler(this.cmd_MouseUp);
			this.cmdForward.MouseDown += new System.Windows.Forms.MouseEventHandler(this.cmdForward_MouseDown);
			// 
			// cmdRight
			// 
			this.cmdRight.Image = ((System.Drawing.Bitmap)(resources.GetObject("cmdRight.Image")));
			this.cmdRight.Location = new System.Drawing.Point(104, 56);
			this.cmdRight.Name = "cmdRight";
			this.cmdRight.Size = new System.Drawing.Size(40, 40);
			this.cmdRight.TabIndex = 6;
			this.cmdRight.MouseUp += new System.Windows.Forms.MouseEventHandler(this.cmd_MouseUp);
			this.cmdRight.MouseDown += new System.Windows.Forms.MouseEventHandler(this.cmdRight_MouseDown);
			// 
			// cmdLeft
			// 
			this.cmdLeft.Image = ((System.Drawing.Bitmap)(resources.GetObject("cmdLeft.Image")));
			this.cmdLeft.Location = new System.Drawing.Point(8, 56);
			this.cmdLeft.Name = "cmdLeft";
			this.cmdLeft.Size = new System.Drawing.Size(40, 40);
			this.cmdLeft.TabIndex = 4;
			this.cmdLeft.MouseUp += new System.Windows.Forms.MouseEventHandler(this.cmd_MouseUp);
			this.cmdLeft.MouseDown += new System.Windows.Forms.MouseEventHandler(this.cmdLeft_MouseDown);
			// 
			// nmGreifer
			// 
			this.nmGreifer.Location = new System.Drawing.Point(208, 192);
			this.nmGreifer.Maximum = new System.Decimal(new int[] {
																	  36,
																	  0,
																	  0,
																	  0});
			this.nmGreifer.Minimum = new System.Decimal(new int[] {
																	  10,
																	  0,
																	  0,
																	  0});
			this.nmGreifer.Name = "nmGreifer";
			this.nmGreifer.Size = new System.Drawing.Size(64, 20);
			this.nmGreifer.TabIndex = 10;
			this.nmGreifer.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.nmGreifer.Value = new System.Decimal(new int[] {
																	21,
																	0,
																	0,
																	0});
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(200, 176);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(88, 16);
			this.label1.TabIndex = 11;
			this.label1.Text = "SchlieImpulse";
			// 
			// lblReady
			// 
			this.lblReady.BackColor = System.Drawing.Color.Gray;
			this.lblReady.Location = new System.Drawing.Point(16, 304);
			this.lblReady.Name = "lblReady";
			this.lblReady.Size = new System.Drawing.Size(24, 24);
			this.lblReady.TabIndex = 12;
			// 
			// lblSpannung
			// 
			this.lblSpannung.BackColor = System.Drawing.Color.Gainsboro;
			this.lblSpannung.Location = new System.Drawing.Point(136, 304);
			this.lblSpannung.Name = "lblSpannung";
			this.lblSpannung.Size = new System.Drawing.Size(32, 16);
			this.lblSpannung.TabIndex = 13;
			this.lblSpannung.Text = "0";
			this.lblSpannung.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(48, 304);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(80, 16);
			this.label3.TabIndex = 14;
			this.label3.Text = "Spannung [V]";
			// 
			// tmrSpannung
			// 
			this.tmrSpannung.Tick += new System.EventHandler(this.tmrSpannung_Tick);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(24, 176);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(96, 40);
			this.label2.TabIndex = 15;
			this.label2.Text = "Strg-Key : halbe Geschwindigkeit";
			// 
			// frmMain
			// 
			this.AcceptButton = this.cmdAction;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.cmdEnde;
			this.ClientSize = new System.Drawing.Size(302, 349);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label2,
																		  this.label3,
																		  this.lblSpannung,
																		  this.lblReady,
																		  this.label1,
																		  this.nmGreifer,
																		  this.pnlCommands,
																		  this.cmdAction,
																		  this.cmdEnde,
																		  this.lblVersion,
																		  this.lblStatus});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.KeyPreview = true;
			this.MaximizeBox = false;
			this.Name = "frmMain";
			this.Text = "RaupenGreif";
			this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.frmMain_KeyDown);
			this.Closing += new System.ComponentModel.CancelEventHandler(this.frmMain_Closing);
			this.KeyUp += new System.Windows.Forms.KeyEventHandler(this.frmMain_KeyUp);
			this.pnlCommands.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.nmGreifer)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}

		private void cmdAction_Click(object sender, System.EventArgs e) {
			try {
				ft.OpenInterface(IFTypen.ftROBO_first_USB, 0, true);
				lblVersion.Text     = "Version : " + ft.ActDevice.Firmware;
				cmdEnde.Text        = "HALT";
				cmdAction.Enabled   = false;
				pnlCommands.Enabled = true;
				GrCount             = (int)nmGreifer.Value;
				GreiferAuf();
				GreiferHoch();
				tmrSpannung.Enabled = true;
				lblStatus.Text      = "Ready to Run";
			}
			catch (FishFaceException eft) {
				lblStatus.Text = eft.Message;
			}
		}

		private void cmdEnde_Click(object sender, System.EventArgs e) {
			if(cmdEnde.Text == "HALT") EndProc(); else this.Close();
		}

		private void frmMain_Closing(object sender, 
			System.ComponentModel.CancelEventArgs e) {
			if(cmdEnde.Text == "HALT") e.Cancel = true;
		}

		private void tmrSpannung_Tick(object sender, System.EventArgs e) {
			try {
				lblReady.BackColor = Color.Green;
				lblSpannung.Text = (ft.GetVoltage(Inp.AV)/100.0).ToString("0.00");
			}
			catch(FishFaceException eft) {
				lblReady.BackColor = Color.Red;
				lblStatus.Text = eft.Message;
			}
		}

		// --- Steuerung ber Buttons --------------------------------------------

		private void cmdLeft_MouseDown(object sender, 
			System.Windows.Forms.MouseEventArgs e) {
			TurnLeft();
		}

		private void cmdRight_MouseDown(object sender, 
			System.Windows.Forms.MouseEventArgs e) {
			TurnRight();
		}

		private void cmdForward_MouseDown(object sender, 
			System.Windows.Forms.MouseEventArgs e) {
			GoForward();
		}

		private void cmdBack_MouseDown(object sender, 
			System.Windows.Forms.MouseEventArgs e) {
			GoBack();
		}

		private void cmdLeftF_MouseDown(object sender, 
			System.Windows.Forms.MouseEventArgs e) {
			GoForwardLeft();		
		}

		private void cmdRightF_MouseDown(object sender, 
			System.Windows.Forms.MouseEventArgs e) {
			GoForwardRight();
		}

		private void cmdLeftB_MouseDown(object sender, 
			System.Windows.Forms.MouseEventArgs e) {
			GoBackLeft();
		}

		private void cmdRightB_MouseDown(object sender, 
			System.Windows.Forms.MouseEventArgs e) {
			GoBackRight();
		}
		private void cmd_MouseUp(object sender, 
			System.Windows.Forms.MouseEventArgs e) {
			StopAll();
		}

		private void cmdGrAuf_Click(object sender, System.EventArgs e) {
			GreiferAuf();
		}

		private void cmdGrZu_Click(object sender, System.EventArgs e) {
			GreiferZu();
		}

		private void cmdGrHoch_Click(object sender, System.EventArgs e) {
			GreiferHoch();
		}

		private void cmdGrRunter_Click(object sender, System.EventArgs e) {
			GreiferRunter();
		}

		// --- Steuerung ber Tastatur ------------------------------------------------

		private void frmMain_KeyDown(object sender, 
			System.Windows.Forms.KeyEventArgs e) {
			if(cmdAction.Enabled) return;
			switch (e.KeyValue) {
				case 33:              // --- Greifer Hoch;
					if(HubStatus == eHubUnten) GreiferHoch();
					break;
				case 34:              // --- Greifer Runter;
					if(HubStatus == eHubOben) GreiferRunter();
					break;
				case 35:              // --- Greifer Zu;
					if(GreiferStatus == eGrOffen) GreiferZu();
					break;
				case 36:              // --- Greifer Auf
					if(GreiferStatus == eGrImpuls) GreiferAuf();
					break;
				case 100:
				case 37:              // --- Left
					TurnLeft();
					break;
				case 104:
				case 38:              // --- Up
					GoForward();
					break;
				case 102:
				case 39:              // --- Right
					TurnRight();
					break;
				case 98:
				case 40:              // --- Down
					GoBack();
					break;
				case 97:              // --- NumPad1
					GoBackLeft();
					break;
				case 99:              // --- NumPad3
					GoBackRight();
					break;
				case 103:             // --- NumPad7
					GoForwardLeft();
					break;
				case 105:             // --- NumPad9
					GoForwardRight();
					break;
				default:
					break;
			}
			e.Handled = true;
		}

		private void frmMain_KeyUp(object sender, 
			System.Windows.Forms.KeyEventArgs e) {
			if(cmdAction.Enabled) return;
			switch (e.KeyValue) {
				case 37: 
				case 38:
				case 39:
				case 40:
				case 97:
				case 98:
				case 99:
				case 100:
				case 102:
				case 103:
				case 104:
				case 105:
					StopAll();
					break;
				default:
					break;
			}
			e.Handled = true;		
		}

		// --- Arbeitsroutinen ------------------------------------

		private void EndProc() {
			ft.CloseInterface();
			cmdEnde.Text        = "ENDE";
			cmdAction.Enabled   = true;
			pnlCommands.Enabled = false;
			tmrSpannung.Enabled = false;
			lblStatus.Text      = "Interface angehalten";
		}

		private void TurnLeft() {
			if(Control.ModifierKeys == Keys.Control) Speed = 6; else Speed = 7;
			ft.SetMotor(mLinks,  cVor, Speed);
			ft.SetMotor(mRechts, cRuck, Speed);
			lblStatus.Text = "Turn Left";
		}
		private void TurnRight() {
			if(Control.ModifierKeys == Keys.Control) Speed = 6; else Speed = 7;
			ft.SetMotor(mLinks,  cRuck, Speed);
			ft.SetMotor(mRechts, cVor, Speed);		
			lblStatus.Text = "Turn Right";
		}
		private void GoForward() {
			if(Control.ModifierKeys == Keys.Control) Speed = 4; else Speed = 7;
			ft.SetMotor(mLinks,  cVor, Speed);
			ft.SetMotor(mRechts, cVor, Speed);	
			lblStatus.Text = "Go Forward";
		}
		private void GoForwardLeft() {
			ft.SetMotor(mLinks,  cVor, 7);
			ft.SetMotor(mRechts, cVor, 3);	
			lblStatus.Text = "Go ForwardLeft";
		}
		private void GoForwardRight() {
			ft.SetMotor(mLinks,  cVor, 3);
			ft.SetMotor(mRechts, cVor, 7);	
			lblStatus.Text = "Go Forward";
		}
		private void GoBack() {
			if(Control.ModifierKeys == Keys.Control) Speed = 4; else Speed = 7;
			ft.SetMotor(mLinks,  cRuck, Speed);
			ft.SetMotor(mRechts, cRuck, Speed);			
			lblStatus.Text = "Go Back";
		}
		private void GoBackLeft() {
			ft.SetMotor(mLinks,  cRuck, 7);
			ft.SetMotor(mRechts, cRuck, 3);			
			lblStatus.Text = "Go BackLeft";
		}
		private void GoBackRight() {
			ft.SetMotor(mLinks,  cRuck, 3);
			ft.SetMotor(mRechts, cRuck, 7);			
			lblStatus.Text = "Go BackRight";
		}
		private void StopAll() {
			ft.SetMotor(mLinks,  cAus);
			ft.SetMotor(mRechts, cAus);		
			lblStatus.Text = "Steht";
		}
		private void GreiferAuf() {
			GreiferStatus = cBusy;
			lblStatus.Text = "Greifer ffnet";
			cmdGrAuf.Enabled = false;
			ft.SetMotor(mGreifer, cGrAuf);
			ft.WaitForInput(eGrOffen);
			ft.SetMotor(mGreifer, cAus);
			cmdGrZu.Enabled = true;
			GreiferStatus = eGrOffen;
			lblStatus.Text = "Greifer offen";
		}
		private void GreiferZu() {
			GreiferStatus = cBusy;
			lblStatus.Text = "Greifer schliet";
			cmdGrZu.Enabled = false;
			ft.SetMotor(mGreifer, cGrZu);
			ft.WaitForChange(eGrImpuls, GrCount);
			ft.SetMotor(mGreifer, cAus);
			cmdGrAuf.Enabled = true;
			GreiferStatus = eGrImpuls;
			lblStatus.Text = "Greifer geschlossen";
		}
		private void GreiferHoch() {
			HubStatus = cBusy;
			lblStatus.Text = "Greifer fhrt hoch";
			cmdGrHoch.Enabled = false;
			ft.SetMotor(mHub, cHubHoch);
			ft.WaitForInput(eHubOben);
			ft.SetMotor(mHub, cAus);
			cmdGrRunter.Enabled = true;
			HubStatus = eHubOben;
			lblStatus.Text = "Greifer oben";
		}
		private void GreiferRunter() {
			HubStatus = cBusy;
			lblStatus.Text = "Greifer fhrt runter";
			cmdGrRunter.Enabled = false;
			ft.SetMotor(mHub, cHubRunter);
			ft.WaitForInput(eHubUnten);
			ft.SetMotor(mHub, cAus);
			cmdGrHoch.Enabled = true;
			HubStatus = eHubUnten;
			lblStatus.Text = "Greifer unten";
		}
	}
}
